/*
** Header: tcpae_client.h
**	- contains the interface to the tcpae client software
**  - the API constants are not located in this client release, contact chris
**		if you are interested in developing your own API implementation
** Author: cf haupt (c) 1992, All rights Reserved
** Modified:
**	13-jun-1992 -- upgraded to conform to paper spec
*/

#pragma once

/************************************************************************/
/* constants */

/* result codes*/
#define noErr                   0
#define kNoHost                 -1
#define kNoContext              -2
#define kRemoteNotAnswer        -3
#define kCantOpenOutput         -4
#define kCantOpenInput          -5
#define kMaxLink                -6
#define kBadPacket				-7
#define kBadResult				-8
#define kInvalidContext			-9

/* filterFlags returned in TCPAEGateStatus StatusRec.filterFlags */
#define     kAccessFilter       0x01
#define     kAEAppFilter        0x02
#define     kAEEvtFilter        0x04
#define     kAETypFilter        0x08

/************************************************************************/
/* type & structures */

/* Macintosh equiv types */
typedef long int OSType, OSErr;

/* the status buffer returned by TCPAEGateStatus */
typedef struct _StatusRec
{
    short   version;        /* version of protocol          */
    short   filterFlags;    /* is event filtering active? */
    long    packetsServed   /* number of packets served via gateway*/
} StatusRec;

/************************************************************************/
/* prototypes */
OSErr	TCPAEInit(void);
OSErr	TCPAEOpenGate (short int *context, char *dottedHost);
OSErr	TCPAECloseGate(short context);
OSErr	TCPAEGateStatus(short context, StatusRec *rec);
OSErr	TCPAESendOAPP(short context, char *target);
OSErr	TCPAESendQUIT(short context, char *target);
OSErr	TCPAESendDOSC(short context, char *target, char *buffer);

