/*
	GlobalPatch.h
	
	Sub-class of TrapPatch that uses the SetTrapAddress available at INIT time
	to patch in every context of the system.
	
	Part of PatchWorks, the Extension Development Framework.
	
	by Mouse Herrell & Patrick Beard.
	
	Permission is granted to use this source code for any purpose, as long
	as the copyright notice is maintained.
	
	 1992 Berkeley Systems, Inc.
 */

#pragma once

#ifndef __GLOBAL_PATCH__
#define __GLOBAL_PATCH__

#include "GenericPatch.h"

class GlobalPatch : public GenericPatch {
public:
	static void SaveTrapAddresses(void);

protected:
	virtual	PatchProcPtr Get(void);
	virtual	void Set(PatchProcPtr proc);
	
private:
	static PatchProcPtr theirGetTrapAddress;
	static PatchProcPtr theirSetTrapAddress;
};

#endif
