/*
	ScalperPatch.h
	
	Performs trap patching using Scalper mechanism.
	
	by Mouse Herrel & Patrick C. Beard.
 */

#pragma once

#ifndef	__SCALPER_PATCH__
#define __SCALPER_PATCH__

#include "Scalper.h"
#include "Patch.h"

class ScalperPatch : public TrapPatch {
protected:
	ScalperPatch();
	virtual ~ScalperPatch();
	
	virtual PatchProcPtr Get();
	virtual void Set(PatchProcPtr proc);

public:
	static void InstallScalper(void);
	static void RemoveScalper(void);
	static pascal StringPtr	Unpatch(void);

private:
	static ScalperHook theirHook;
};

#endif
